//$Id: add-resource.cc,v 1.3 2001/02/24 16:04:14 cactus Exp $ -*- c++ -*-

/* Guikachu Copyright (C) 2001 RDI Gerg <cactus@cactus.rulez.org>
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License version 2
 * as published by the Free Software Foundation.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#include "add-resource.h"

#include <gtk--.h>
#include <gnome--/dialog.h>
#include <gnome--/about.h>
#include <glade/glade.h>

#include "resource-manager.h"

using namespace Guikachu;

GUI::AddResourceWin::AddResourceWin ()
{
    gui = glade_xml_new (GLADEDIR "/guikachu.glade", 0);

    Gtk::OptionMenu *optmenu;
    Gtk::Menu       *menu;
    
    dialog = Gtk::wrap (GNOME_DIALOG (glade_xml_get_widget (gui, "dlg_add")));
    optmenu = Gtk::wrap (GTK_OPTION_MENU (glade_xml_get_widget (gui, "add_type")));
    entry = Gtk::wrap (GTK_ENTRY (glade_xml_get_widget (gui, "add_name")));

    menu = optmenu->get_menu ();
    menu->items ().clear ();
    menu->items ().push_back (Gtk::Menu_Helpers::MenuElem
			      (_("Dialog"),
			       SigC::bind (
				   SigC::slot (this, &AddResourceWin::resource_type_cb),
				   Resources::RESOURCE_DIALOG)));
    menu->items ().push_back (Gtk::Menu_Helpers::MenuElem
			      (_("Menu"),
			       SigC::bind (
				   SigC::slot (this, &AddResourceWin::resource_type_cb),
				   Resources::RESOURCE_MENU)));
    menu->items ().push_back (Gtk::Menu_Helpers::MenuElem
			      (_("String"),
			       SigC::bind (
				   SigC::slot (this, &AddResourceWin::resource_type_cb),
				   Resources::RESOURCE_STRING)));

    optmenu->set_history (0);
    res_type = Resources::RESOURCE_DIALOG;

    dialog->editable_enters (*entry);
    dialog->close_hides (true);
}

GUI::AddResourceWin::~AddResourceWin ()
{
    dialog->destroy ();
    gtk_object_unref (GTK_OBJECT (gui));    
}

void GUI::AddResourceWin::run ()
{
    int dialog_result;

    dialog_result = dialog->run_and_close ();

    if (dialog_result != -1)
    {
	if (dialog_result == 0)
	    if (entry->get_text () != "")
		ResourceManager::create_resource (res_type, entry->get_text ());
    }
}

void GUI::AddResourceWin::resource_type_cb (Resources::Type type)
{
    res_type = type;
}
